package redditi.ui.controller;

import java.util.List;

import redditi.model.CalcolatoreRedditi;
import redditi.model.TipologiaContribuente;

public abstract class Controller {
	
	private UserInteractor userInteractor;
	private CalcolatoreRedditi calcolatoreRedditi;
	private List<TipologiaContribuente> listaTipologie;

	public Controller(UserInteractor userInteractor,
			List<TipologiaContribuente> listaTipologie,
			CalcolatoreRedditi calcolatoreRedditi) {
		this.userInteractor = userInteractor;
		this.calcolatoreRedditi = calcolatoreRedditi;
		this.listaTipologie = listaTipologie;
	}

	public List<TipologiaContribuente> getListaTipologie() {
		return listaTipologie;
	}

	public UserInteractor getUserInteractor() {
		return this.userInteractor;
	}
	
	public abstract String calcolaImpostaLorda(double reddito, double importo);
	public abstract String calcolaImpostaNetta(double spese, double percentuale);
		
	public CalcolatoreRedditi getCalcolatoreRedditi(){
		return this.calcolatoreRedditi;
	}

	public double getAliquotaSpeseMediche() {
		return 0.2; // per non fare un altro file..
	}

}
